
% This function is called by a different function, "object_polariz3", which
% itself is called by main Matlab program running imaging polarimetric self-calibration.
% 
% You are very welcome to use this code. For this, clearly acknowledge 
% the source of this code, and cite the paper that describes the algorithm:
% Y. Y. Schechner, "Self-Calibrating Imaging Polarimetry", 
% Proc. IEEE Int. Conference on Computational Photography (ICCP), 2015.
%
% (c) Copyright Yoav Schechner 2015. The matlab code is available for 
% non-commercial use and exploration.  For commercial use contact the
% author. The author is not liable for any damages or loss that might be 
% caused by use or connection to this code. 



function [P,inverseP]=analyzer_matrices(selected_angles,num_of_pixels)

num_of_angles=length(selected_angles);
pc=cos(2*selected_angles*(pi/180));
ps=sin(2*selected_angles*(pi/180));
pc_neto=(pc(2:num_of_angles))';
ps_neto=(ps(2:num_of_angles))';
P=[1 1 0; ones(num_of_angles-1,1),pc_neto, ps_neto];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tildeP=zeros(num_of_angles*num_of_pixels,3*num_of_pixels);
for pixind=1:num_of_pixels,
    urow=(pixind-1)*num_of_angles+1;
    drow=pixind*num_of_angles;
    lcol=(pixind-1)*3+1;
    rcol=pixind*3;    
    tildeP(urow:drow,lcol:rcol)=P;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 inverseP=pinv(tildeP);
